// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/lib/intime/os_mbox.c $
// $Rev: 26099 $
// $Date: 2014-05-16 10:51:54 -0500 (Fri, 16 May 2014) $

// INtime 4 library

#include "main.h"



//*****************************************************************************
// returns err_no: 0 = ok, !=0 = error value
int os_mbox_alloc(os_mbox_t** mbox)
{
	int	err_no;

	for (;;)
	{
		if (mbox == NULL)
		{
			err_no	= EINVAL;
			break;
		}

		mbox[0]	= malloc(sizeof(os_mbox_t));

		if (mbox[0] == NULL)
		{
			err_no	= ENOMEM;
			break;
		}

		memset(mbox[0], 0, sizeof(os_mbox_t));
		mbox[0]->mbox	= CreateRtMailbox(DATA_MAILBOX);

		if (mbox[0]->mbox == BAD_RTHANDLE)
		{
			free(mbox[0]);
			mbox[0]	= 0;
			err_no	= GetLastRtError();
			break;
		}

		err_no	= 0;
		break;
	}

	return(err_no);
}



//*****************************************************************************
void os_mbox_free(os_mbox_t** mbox)
{
	if (mbox)
	{
		if (mbox[0])
		{
			if (mbox[0]->mbox != BAD_RTHANDLE)
				DeleteRtMailbox(mbox[0]->mbox);

			memset(mbox[0], 0, sizeof(os_mbox_t));
			free(mbox[0]);
		}

		mbox[0]	= NULL;
	}
}


