// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/lib/intime/os_mem.c $
// $Rev: 26099 $
// $Date: 2014-05-16 10:51:54 -0500 (Fri, 16 May 2014) $

// INtime 4 library

#include "main.h"



//*****************************************************************************
// returns err_no: 0 = ok, !=0 = error value
int os_mem_handle_create(void* ptr, int bytes, u32* offset, RTHANDLE* mem)
{
	int	err_no;

	for (;;)
	{
		if ((ptr == NULL) || (bytes <= 0) || (offset == NULL) || (mem == NULL))
		{
			err_no	= EINVAL;
			break;
		}

		offset[0]	= (u32) ptr % 4096;
		bytes		+= offset[0];
		ptr			= (void*) ((u32) ptr - offset[0]);
		mem[0]		= CreateRtMemoryHandle(ptr, bytes);
		err_no		= 0;
		break;
	}

	return(err_no);
}



//*****************************************************************************
void os_mem_handle_destroy(RTHANDLE* mem)
{
	if (mem)
	{
		if (mem[0] != BAD_RTHANDLE)
			DeleteRtMemoryHandle(mem[0]);

		mem[0]	= BAD_RTHANDLE;
	}
}


